//===============================================
// (C) Easy Soft 01/2002
// Raisonance RC-51, version 6.4.16
//===============================================
// rezonator 7,3728MHz

//wybr modelu pamici
#pragma SMALL
//doczenie definicji rejestrw mikrokontrolera
#include <reg51.h>
//definicje linii sterujcych wywietaniem
sbit		dataline		= P1^0;
sbit		shiftline 	= P1^1;
sbit		latchline 	= P1^2;
//licznik impulsw
unsigned int counter = 0;


//warto rejestru timera TH1, TL1 nie jest modyfikowane liczy zawsze od 0
const	char interval = 0b11111000;

/* tutaj wzorce cyfr

	   d5
    ======
d1 |	    | d6
	|  d0  |
	 ======
d7 |		 | d4
	|      |
	 ======
	   d2						*/
	   
char code patterns[10] = { 0x09,0xAF,0x1A,0x8A,0xAC,0xC8,0x48,0x8F,0x08,0x88 };
//przecinek = d3, wyczenie cyfry = 0xFF 
char *TPatterns = &patterns;

//tutaj kolejno zaczania
char code digits[6] = { 0xFE,0xFD,0xFB,0xF7,0xEF,0xDF };
char *TDigits = &digits;

//bufor wywietlacza w RAM
char data display[7];
char data *TDisplay = &display;


//zamiana zmiennej x na zawarto bufora do wywietlenia
void Translate(unsigned int x)
{
	char temp;
	
	ET1 = 0;									//wyczenie na czas translacji wywietlania (migotanie LED)
	TDisplay = &display + 5;			//zaczynamy translacj od najmodszej cyfry
	for (temp=0; temp<6; temp++)
	{
		*TDisplay = *(TPatterns + x % 10);	//adres wzorca + (reszta z dzielenia przez 10)
		TDisplay--;
		x /= 10;
	}
	TDisplay ++;							//po poprzedniej ptli TDisplay jest o 1 za mae
	for (temp=0; temp<5; temp++)		//wygaszenie zer nieznaczcych od pozycji 1..5
	{
		if (*TDisplay == *TPatterns) *TDisplay = 0xFF; else break;	//jeli napotkamy znak rny od 0,to koniec
		TDisplay++;
	}
	ET1 = 1;									//zaczenie wywietlania
}


//procedura obsugi przerwania INT0
//zwikszanie licznika impulsw
void IncrementCounter(void) interrupt 0
{
	counter++;								//zwikszenie licznika impulsw
	Translate(counter);					//zamiana counter na liczby do wywietlenia
}


//procedura obsugi przerwania od timer'a 1
//wysanie zmiennej 2-bajtowej do wywietlacza - 1 znak z bufora display
void DisplaySend(void) interrupt 3
{
	char temp;
	unsigned int x;
	
	TH1 = interval;						//odwieenie zawartoci timera 1
	TDisplay++;								//nastpna pozycja do wywietlenia
	TDigits++;
	if (*TDisplay == 0)					//jeli osignito koniec bufora,to wr do pocztku
	{
		TDisplay = &display;
		TDigits = &digits;
	}
	x = *TDigits;							//x przyjmuje warto liczby do wysania
	x <<= 8;									//skada si ona z bajtu wzorca cyfry i bajtu kolejnoci zaczenia
	x |= *TDisplay;
	
	for (temp = 0; temp<16; temp++)	//wysanie cyfry poprzez przypisanie flagi C do wyjcia danych
	{
		x <<= 1;
		dataline = CY;
		shiftline = 1;						//impuls na wyjciu zegara przesuwajcego
		shiftline = 0;
	}
	latchline = 1;							//przepisanie danych do wyj rejestrw
	latchline = 0;
}

//program gwny
void main(void)
{
	*(TDisplay + 6) = 0x00;				//tutaj kod koca danych
	Translate(counter);					//wywietlenia 0.
	TMOD = 0x11;							//oba timery jako 16 bitowe,kontrolowane wewntrznie
	TH1 = interval;						//przerwanie wywoywane z czstotliw.okoo 75Hz
	ET1 = 1;									//zezwolenie na przerwanie od timer'a 1
	TR1 = 1;									//uruchomienie timer'a 1
	IT0 = 1;									//opadajce zbocze na INT0 wyzwala przerwanie
	EX0 = 1;									//zaczenie przerwania INT0
	EA = 1;									//zezwolenie na przyjmowanie przerwa
	while (1);								//oczekiwanie na przerwania
}

