/* prosty program demonstracyjny "odczyt pojedynczego klawisza"
   klawisz wczony pomidzy mas a port P1.2, stan aktywny = L;
   rezonator kwarcowy 8MHz */
   
#include <reg51.h>				//doczenie definicji rejestrw mikrokontrolera

sbit PortKey = P1^2;				//definicja bitu portu do ktrego podczony klawisz
sbit Active = P1^3;				//port przyjmuje stan niski, gdy klawisz jest wcinity


//opnienie okoo 1 milisekundy dla kwarcu 8MHz
void Delay(unsigned int time)
{
	unsigned int j;
	
	while (time >= 1)				//wykonanie ptli FOR zajmuje okoo 1 sek.
	{									//ptla jest powtarzana TIME razy
		for (j=0; j<65; j++);
		time--;
	}
}

//funkcja - reakcja na nacinicie klawisza
void KeyPressed(void)
{
	Active = 0;
}

//funkcja - reakcja, gdy klawisz nie jest wcinity
void KeyNotPressed(void)
{
	Active = 1;
}

//pocztek programu gwnego
void main(void)
{
	while (1)						//ptla nieskoczona
	{
		if (!PortKey)
		{
			Delay(20);				//opnienie 20 ms
			if (!PortKey) 			//ponowny odczyt klawisz i podjcie akcji, jeli nadal wcinity
			{
				KeyPressed;
				while (!PortKey);	//oczekiwanie na zwolnienie klawisza
			}
		}
		KeyNotPressed();			//podjcie akcji, gdy klawisz nie jest wcinity
	}
}
 
