/* prosty program demonstracyjny "odczyt klawiszy podczonych do P1"
   klawisz wczony pomidzy mas a bit portu P1, stan aktywny = L
   klawisze podczone od P1.2 do P1.6; rezonator kwarcowy 8MHz */
   
#include <reg51.h>			//doczenie definicji rejestrw mikrokontrolera
#include <stdio.h>			//biblioteka zawierajca funkcj printf()

#define PortKey	P1;		//definicja bitu portu klawisza
unsigned char	 buf;			//zmienna przechowujca stan klawiszy

//opnienie okoo 1 milisekundy dla kwarcu 8MHz
void Delay(unsigned int time)
{
	unsigned int j;
	
	while (time >= 1)			//wykonanie ptli FOR zajmuje okoo 1 msek.
	{								//ptla jest powtarzana TIME razy
		for (j=0; j<65; j++);
		time--;
	}
}

//odczyt klawiatury podczonej do PortKey
char KbdRead()
{
	unsigned char b;

	b = PortKey;				//odczytaj stan portu klawiatury
	b |= 3;						//ustaw dwa najmodsze, nie uywane przez klawiatur bity
	return (~b);				//zwr odczytan warto po zanegowaniu
}


//pocztek programu gwnego
void main(void)
{
	while (1)					//ptla nieskoczona
	{
		buf = KbdRead();
		if (buf)					//jeli rezultat rny od 0 - sprawd
		{
			Delay(20);			//opnienie 20ms
			if (buf == KbdRead())	//ponowny odczyt klawisza i akcja,
	 		{								//jeli nadal wcinity
 				if (buf && 0x04) printf("%s\n", "Klawisz 1");
				if (buf && 0x08) printf("%s\n", "Klawisz 2");
				if (buf && 0x10) printf("%s\n", "Klawisz 3");
				if (buf && 0x20) printf("%s\n", "Klawisz 4");
				if (buf && 0x40) printf("%s\n", "Klawisz 5");
			}
		}
	}
}

