;**************************************************************************
;modu asemblera do programatora ISP, zapis i odczyt bajtu poprzez spi
;**************************************************************************
$include(reg_51.pdf)

ISP_asm segment code

RESET		bit	P3.3						;port sygnau reset
;RESET		bit	P1.7
MOSI		bit	P1.2						;port wyjcia szeregowego mosi
MISO		bit	P1.3						;port wejcia szeregowego miso
SCK		bit	P1.4						;sygna zegarowy sck

public _wrser								;zapis bajtu poprzez spi
public rdser								;odczyt bajtu poprzez spi
public _delayms							;opnienie 1ms

public RESET								;definicje bitw sfr
public MOSI
public MISO
public SCK


;**************************************************************************
rseg ISP_asm


;zapis bajtu do spi, bajt przekazywany w rejestrze R7
;spodziewane, e SCK=0 przed wywoaniem / zwracane SCK = 0 po zakoczeniu pracy
_wrser:	push	B							;rejestr B jako licznik
			mov	B,#8
			mov	A,R7						;do akumulatora bajt do wysania
wrser_loop:
			rlc	A							;przeniesienie najstarszego bitu do flagi CY
			mov	MOSI,C					;ustawienie linii wyjciowej
			call	sck_pulse				;impuls zegarowy na linii SCK
			djnz	B,wrser_loop			;czy ju powtrzono dla 8 bitw?
			pop	B							;odtwrz zawarto B
			ret

			
;odczyt bajtu z spi, bajt zwracany w R7
;spodziewane, e SCK=0 przed wywoaniem / zwracane SCK = 0 po zakoczeniu pracy
rdser:	push	B							;rejestr B jako licznik
			mov	B,#8
rdser_loop:
			mov	C,MISO					;odczyt danych (opadajce zbocze wrser ju spowodowao, e na MISO jest 1-szy bit danych)
			rlc	A							;wprowadzenie do akumulatora
			call	sck_pulse				;impuls zegarowy na SCK
			djnz	B,rdser_loop			;czy ju powtrzono operacj dla 8 bitw?
			pop	B							;odtwrz zawarto B
			mov	R7,A						;parametr zwracany w R7
			ret


;impuls zegarowy na linii SCK
sck_pulse:
			setb	SCK						;narastajce zbocze SCK
			mov	R7,#4
			djnz	R7,$
			clr	SCK						;opadajce zbocze SCK
			mov	R7,#4
			djnz	R7,$
			ret

			
;ptla opnienia - 1ms
_delayms:
			push	ACC
			push	B
			mov	A,R7
			mov	B,#0
dloop:
			djnz	B,$						;~500us / 11.0592MHz
			djnz	B,$
			djnz	ACC,dloop
			
			pop	B
			pop	ACC
			ret


END
